/**
 * @Author: wzy
 * @Date: 2021-11-19
 * @LastEditTime: 
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @filePath:
 */

#include "PD_TrffcEffcy.h"
using namespace ADC::PD_TrffcEffcy;

TrffcEffcy::TrffcEffcy(const std::vector<ADC::PD_EgoVehTrj::EgoVeh_TrjPnt>& EgoVeh_trace_list){
    if (init(EgoVeh_trace_list) == false){
        // std::cout << "ATTENTION: TrffcEffcy init is false!" << std::endl;
        return;
    }
}

bool TrffcEffcy::init(const std::vector<ADC::PD_EgoVehTrj::EgoVeh_TrjPnt>& EgoVeh_trace_list){
    
    if (EgoVeh_trace_list.empty()){
        // std::cout << "ATTENTION: <TrffcEffcy> EgoVeh_trace_list is empty!" << std::endl;
        initFlag = false;
    }
    else{
        _egoVeh_TrjPnt.clear();
        initFlag = true;
        PD_DynmcObjRsk::EgoVeh_Point egoveh_TrjPnt;
        for (int i = 0; i < EgoVeh_trace_list.size(); i++){
            egoveh_TrjPnt.t = EgoVeh_trace_list[i].t;
            egoveh_TrjPnt.s = EgoVeh_trace_list[i].s;
            egoveh_TrjPnt.l = EgoVeh_trace_list[i].l;
            egoveh_TrjPnt.vs = EgoVeh_trace_list[i].vx;
            egoveh_TrjPnt.as = EgoVeh_trace_list[i].ax;
            egoveh_TrjPnt.jks = EgoVeh_trace_list[i].jkx;
            _egoVeh_TrjPnt.push_back(egoveh_TrjPnt);
        }
    }
    return initFlag;
}

float TrffcEffcy::CalculateEffLongDrvDis(){
    m_EffLongDrvDis = _egoVeh_TrjPnt.back().s;
    return m_EffLongDrvDis;
}

float TrffcEffcy::CalculateEffEndSpd(){
    m_EffEndSpd = _egoVeh_TrjPnt.back().vs;
    return m_EffEndSpd;
}

float TrffcEffcy::CalculateEffAvgSpd(){
    float SumEffSpd = 0;
    for (int i = 0; i < _egoVeh_TrjPnt.size(); i++){
        SumEffSpd += _egoVeh_TrjPnt[i].vs;
    } 
    float num_egoVeh_TrjPnt = _egoVeh_TrjPnt.size();
    if (_egoVeh_TrjPnt.empty()){
        num_egoVeh_TrjPnt = 1e-10;
    }
    m_EffAvgSpd = SumEffSpd / num_egoVeh_TrjPnt;
    return m_EffAvgSpd;
}

void TrffcEffcy::process(){
    if (initFlag != true){
        // std::cout << "ATTENTION: Data reading of PD_TrffcEffcy is error" << std::endl;
        return;
    }
    //TJA阶段赋默认值
    // m_EffLongDrvDis = 50;
    // m_EffEndSpd = 10;
    // m_EffAvgSpd = 12;

    CalculateEffLongDrvDis();
    CalculateEffEndSpd();
    CalculateEffAvgSpd();
}